/* queen8skeleton.cpp : Edit and save as the Queen8.cpp in a  Console Application project Queen8.dsw, 
that has Queen8.cpp as the project's only source file member.  Fill in the missing code at the 6 places 
flagged by the phrase Your code.
You should be able to give any integer as the command line input, like  >Queen8 4
Your output from  >Queen8 8 
should start with: A1 B5 C8 D6 E3 F7 G2 H4.
and end with:  A8 B4 C1 D3 E6 F2 G7 H5. .... etc.

Spring 2002.*/

#pragma warning(disable:4786) 
// The debugger can't handle symbols more than 255 characters long.
// STL often creates symbols longer than that, so we disable the warning by this "pragma" line.
#include <iostream> //Use this instead of iostream.h for standard C++
#include <vector> //STL template.  Note that you don't have .h at end.
#include <list> //STL template
using namespace std; //Need this line to use STL templates with Visual C++.

//============================Queen=====================
class Queen
{
public:
	static int BOARDSIZE;
	int _col, _row;
	Queen(int col = 0, int row = 0):_col(col),_row(row){}
	Queen(const Queen &q):_col(q._col),_row(q._row){}
	bool attacks(Queen &q);
	friend ostream& operator<<( ostream& os, Queen& queen);
};

int Queen::BOARDSIZE = 8; //May be changed in main.

ostream& operator<< ( ostream& os, Queen& queen )
{
	static char letter[26] = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
	os << letter[queen._col % 26] << queen._row + 1; //Reuse letters if more than 26 cols.
	return os;
}

bool Queen::attacks(Queen &q)
{
//(1) Your code.
	return true; //Dummy line so skeleton will compile
}
//===========================State====================

class State : public vector<Queen>
{
public:
	State(){}
	State(Queen &q){push_back(q);}
	State(const State &s, const Queen &q):vector<Queen>(s){push_back(q);}
	bool isLegal(); /* We check only if last queen is not attacked
		by earlier queen.  Don't waste time cheching earlier ones,m
		as we plan to build up legal states incrementally. */
	friend ostream& operator<<( ostream& os, State &state);
};

ostream& operator<< ( ostream& os, State &state)
{
	for (int i=0; i<state.size(); i++)
		os << " " << state[i];
	os << ".\n";
	return os;
}

bool State::isLegal()
{ /* Walk through the queens. For a vector template, at(i) is ith element, and back() is last.
Here we check that no earlier queen attacks the last one. */
// (2) Your code.
	return true; //Dummy code so skeleton will compile
}


//============================Node=====================

class Node 
{
private:
	Node * _pparent;
	State _state;
	int _depth;
	int _childcount;
public:
	static int NODESONHEAP;
	static int NODESMEMORYREQ;
	Node():_pparent(NULL), _depth(0), _childcount(0){NODESONHEAP++;}
	Node(State &state, Node *pnode = NULL);
	~Node();
	int nextcol(){return _state.size();} //Special method.
	vector<State> pathstates(); /* Not presently used, but we'll want it
		later to check for repeated states. */
	vector<Node*> expand();
	bool isLeaf(){return _depth==Queen::BOARDSIZE;}
	bool isGoal(){return isLeaf();} /* Special.  Note that this only makes
		sense because we only check isGoal for nodes whose states we already
		know have satisfied isLegal.  An illegal leaf would not be a goal.*/
	friend ostream& operator<<( ostream& os, Node *pnode);
};

int Node::NODESONHEAP = 0;
int Node::NODESMEMORYREQ = 0;

Node::Node(State &state, Node *pnode):
	_pparent(pnode),
	_state(state),
	_childcount(0)
{
	if (!_pparent)
		_depth=1;
	else
	{
		_depth = _pparent->_depth+1;
		_pparent->_childcount++;
	}
	NODESONHEAP++;
	if (NODESONHEAP > NODESMEMORYREQ)
		NODESMEMORYREQ = NODESONHEAP;
}

Node::~Node()
{
	if (_pparent)
	{
		(_pparent->_childcount)--;
		if (!(_pparent->_childcount))
			delete _pparent;
	}
	NODESONHEAP--;
}

ostream& operator<< ( ostream& os, Node *pnode )
{
	os << pnode->_state;
	return os;
}

vector<State> Node::pathstates()
{ /* Can check if a State s is in a given stateset by the bool value
	of (stateset.find(s) == stateset.end()) */
	vector<State> stateset;
	Node* pcur = this;
	while (pcur != NULL)
	{
		stateset.push_back(pcur->_state);
		pcur = pcur->_pparent;
	}
	return stateset;
}

vector<Node*> Node::expand()
{
	vector<Node*> newnodes; //Default array is empty.
/* (3) Your code.  If isLeaf, return the empty array.  Otherwise generate the next
possible eight queens for the posistions in the next column to the right.  For
each of these make a State newstate and see if newstate.isLegal().  If so,
use push_back to add a new Node to the newnodes vector.  */
	return newnodes;
}


//============================SearchQueue=====================

class SearchQueue : public list<Node*>
{
private:
	int _nodeshandled;
public:
	SearchQueue():_nodeshandled(1){push_back(new Node());}
	void addToQueue(vector<Node*> &newnodes);
	int nodeshandled(){return _nodeshandled;}
};

void SearchQueue::addToQueue(vector<Node*> &newnodes)
{ /* This method adds the Node* members of newnodes to the queue using push_back 
or push_front.  To make your printout look nicer, add them without reversing
the order that they're in. */
#define DEPTHFIRST
#ifdef DEPTHFIRST
	//(4) Your code.
#else //not DEPTHFIRST, means Breadth First
	//(5) Your code.
#endif
	_nodeshandled += newnodes.size();
}


//============================main=====================

int main(int argc, char* argv[])
{
	if (argc > 1) //The first, or 0th arg is the name of the executable.
		Queen::BOARDSIZE = atoi(argv[1]);
			 //I got rid of the Node::MAXDEPTH variable
	cout << "Your Name's Month Day, 2002, N Queens Program for board size " <<
		Queen::BOARDSIZE << ".\n";
	SearchQueue node_queue;
	int solutionsfound = 0;
	Node *ptestnode = NULL;
	while (!node_queue.empty())
	{
/* (6) Your code.  Use front() to get the first Node* from node_queue and
	 use pop_front() to remove it.  If it's a goal node, print it and
	increment solutionsfound. If it's a leaf and not a goal delete it.
	If it's not a goal and not a leaf, expand it and add
	the new nodes to the node_queue. */
	}
	cout << "Your Name's Month Day, 2002, Eight Queens Program for board size " <<
		 Queen::BOARDSIZE << ".\n";
	cout << "Done searching N Queens solutions.\nFound " <<
		solutionsfound << " solutions.\n"; 
	cout<< "\nTime complexity: Searched " <<	node_queue.nodeshandled()  <<
		" nodes.\n";
	cout << "Space complexity: Max nodes used at one time was "<<
			Node::NODESMEMORYREQ << ".\n" <<
			"Garbage collection: " << Node::NODESONHEAP <<
			" nodes still on heap.";;
	getchar(); //Wait for a keypress.
	return 0;
}
